(* If you provide two files X.ml and X.mli, then X.mli MUST BE the interface of
 * X.ml;
 * so if 'X.mli' declares a 'module type', then 'X.ml'
 * must define a 'module type', but declarations and definitions of 'module
 * type' is the same *)

(* remove the '#use "A.mli"' as said in the replies you received.
 * if 'A.cmi' is already in the directory, you don't require to
 * tell the compiler it has to use it *)

module PrioQueue =
   struct
     type priority = int
     type char_queue = Empty | Node of priority * char * char_queue * char_queue
     exception QueueIsEmpty
     
     let empty = Empty
     let rec insert queue prio elt =
       match queue with
         Empty -> Node(prio, elt, Empty, Empty)
       | Node(p, e, left, right) ->
           if prio <= p
           then Node(prio, elt, insert right p e, left)
           else Node(p, e, insert right prio elt, left)
   end
(* the ';;' is not necessary (like in the mli file) *)

module AbstractPrioQueue = (PrioQueue: A.CharPQueueAbs)
(* again I remove the ';;', note that the signature of the module
 * is found in the A module (see A.mli) *)
