(* Here, you can see that the 'module type' in the C.ml file
 * is exactly the same;
 * but 'module ... = sig ... end' is changed in 'module ... = struct ... end'*)
module type CharPQueueAbs =
  sig
    type priority = int
    type char_queue
    val empty : char_queue
    val insert : char_queue -> int -> char -> char_queue
    exception QueueIsEmpty
  end
module PrioQueue :
  sig
    type priority = int
    type char_queue =
        Empty
      | Node of priority * char * char_queue * char_queue
    exception QueueIsEmpty
    val empty : char_queue
    val insert : char_queue -> priority -> char -> char_queue
  end
module AbstractPrioQueue : CharPQueueAbs
